Loading...
Searching...
No Matches
Unknown Headers
Headers

The unknown headers are handled with msg_unknown_t structure. More...

## Macros

#define | MSG_UNKNOWN_INIT()
| Initializer for structure msg_unknown_t.

## Typedefs

typedef struct msg_unknown_s | msg_unknown_t
| Type for unknown headers.

## Enumerations

enum | { msg_unknown_hash }

## Functions

msg_unknown_t * | msg_unknown_init (msg_unknown_t x[1])
| Initialize a structure msg_unknown_t.
int | msg_is_unknown (msg_header_t const *header)
| Test if header object is instance of msg_unknown_t.
msg_unknown_t * | msg_unknown_dup (su_home_t *home, msg_unknown_t const *header))
| Duplicate (deep copy) `msg_unknown_t`.
msg_unknown_t * | msg_unknown_copy (su_home_t *home, msg_unknown_t const *header))
| Copy a msg_unknown_t header structure.
msg_unknown_t * | msg_unknown_make (su_home_t *home, char const *s)
| Make a header structure msg_unknown_t.
msg_unknown_t * | msg_unknown_format (su_home_t *home, char const *fmt,...)))
| Make a unknown headers from formatting result.

## Variables

msg_parse_f | msg_unknown_d
| Parse a unknown headers.
msg_print_f | msg_unknown_e
| Print a unknown headers.
msg_hclass_t | msg_unknown_class []
| Header class for unknown headers.

## Detailed Description

The unknown headers are handled with msg_unknown_t structure.

The whole unknown header including its name is included in the header value string g_value.

Note
  It is possible to speed up parsing process by creating a parser which does understand only a minimum number of headers. If such a parser is used, some well-known headers are not regocnized or parser, but they are treated as unknown and put unparsed into the list of unknown headers.

## Macro Definition Documentation

## MSG_UNKNOWN_INIT

#define MSG_UNKNOWN_INIT | ( |  | ) |

Initializer for structure msg_unknown_t.

A static msg_unknown_t structure must be initialized with the MSG_UNKNOWN_INIT() macro. For instance,

msg_unknown_t msg_unknown = MSG_UNKNOWN_INIT;
msg_unknown_t
struct msg_unknown_s msg_unknown_t
Type for unknown headers.
Definition msg_types.h:93
MSG_UNKNOWN_INIT
#define MSG_UNKNOWN_INIT()
Initializer for structure msg_unknown_t.
Definition msg_protos.h:91

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_unknown_hash | Hash of unknown headers.

## Function Documentation

## msg_is_unknown()

int msg_is_unknown | ( | msg_header_t const * | header | ) |

inline

Test if header object is instance of msg_unknown_t.

The function msg_is_unknown() returns true (nonzero) if the header class is an instance of unknown headers object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_unknown() returns true (nonzero) if the header object is an instance of header unknown and false (zero) otherwise.

## msg_unknown_copy()

msg_unknown_t * msg_unknown_copy | ( | su_home_t * | home,
|  | msg_unknown_t const * | header )

inline

Copy a msg_unknown_t header structure.

The function msg_unknown_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  unknown = msg_unknown_copy(home, msg->msg_unknown);
  msg_unknown_copy
  msg_unknown_t * msg_unknown_copy(su_home_t *home, msg_unknown_t const *header))
  Copy a msg_unknown_t header structure.
  Definition msg_protos.h:222

Returns
  The function msg_unknown_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_unknown_dup()

msg_unknown_t * msg_unknown_dup | ( | su_home_t * | home,
|  | msg_unknown_t const * | header )

inline

Duplicate (deep copy) `msg_unknown_t`.

The function msg_unknown_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  unknown = msg_unknown_dup(home, msg->msg_unknown);
  msg_unknown_dup
  msg_unknown_t * msg_unknown_dup(su_home_t *home, msg_unknown_t const *header))
  Duplicate (deep copy) msg_unknown_t.
  Definition msg_protos.h:176

Returns
  The function msg_unknown_dup() returns a pointer to the newly duplicated msg_unknown_t header structure, or NULL upon an error.

## msg_unknown_format()

msg_unknown_t * msg_unknown_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a unknown headers from formatting result.

The function msg_unknown_format() makes a new unknown headers object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function msg_unknown_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_unknown_init()

msg_unknown_t * msg_unknown_init | ( | msg_unknown_t | x[1] | ) |

inline

Initialize a structure msg_unknown_t.

An msg_unknown_t structure can be initialized with the msg_unknown_init() function/macro. For instance,

msg_unknown_t msg_unknown;
msg_unknown_init(&msg_unknown);
msg_unknown_init
msg_unknown_t * msg_unknown_init(msg_unknown_t x[1])
Initialize a structure msg_unknown_t.
Definition msg_protos.h:108

Parameters

  x | pointer to msg_unknown_t structure

## msg_unknown_make()

msg_unknown_t * msg_unknown_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_unknown_t.

The function msg_unknown_make() makes a new msg_unknown_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling msg_header_make().

Returns
  The function msg_unknown_make() returns a pointer to newly maked msg_unknown_t header structure, or NULL upon an error.

## Variable Documentation

## msg_unknown_class

msg_hclass_t msg_unknown_class[]

extern

Header class for unknown headers.

The header class msg_unknown_class defines how a unknown headers header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_unknown_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.